/* Testing parallel trig */

#include <stdio.hs>
#include <math.hs>

#define N  32
#define TWOPI 6.2831853

int NB;

domain pair { int i, j;  float x0, v0; };

domain pair P[N][N];

void pair::setup()
 { int offset;
   offset = (this - &P[0][0]);
   i = (offset/N)%N;  j = offset%N;
 }

void pair::prpflt(x)
 float x;
 { mono int u, v;
   for ( u = 0; u < NB; u++)
    { for ( v = 0; v < NB; v++) printf("%9.5f ", P[u][v].x);
      printf("\n"); }
 }

void chktrig()
 { [domain pair].
    if ( (i < NB) && (j < NB ) )
      { float sx, cx;
	cx = TWOPI*i;  printf("2*pi*i:\n");  prpflt(cx);
	cx = cx/NB;  printf("arg:\n");  prpflt(cx);
	sx = (float)sin((double)cx);  printf("sx:\n");   prpflt(sx);
	cx = (float)cos((double)cx);  printf("cx:\n");   prpflt(cx);
      }
 }

void main()
 { NB = 4;  [domain pair].{setup();}; chktrig(); }
